/*
Definitie garpAttributeDefinition class
*/

:-pce_begin_class(
		  garpAttributeDefinition(name),
		  object,
		  "garp attribute definition"
		 ).

variable(name,name,get,"Name of the attribute definition").
variable(remarks,string,none,"Remarks on this attribute definition").
variable(values,chain,none,"Values allowed in this attribute definition").

initialise(AD,
	Name : name,
	Values : chain,
	Remarks : [string]
	):->
	%initialiseer de definitie, zodat ie goed past op CR's..

	AD->+initialise,
	AD->>name(Name),
	AD->>slot(values,new(chain)),
	AD->>values(Values),
	default(Remarks,new(string),RRemarks),
	AD->>remarks(RRemarks).
%%

%%
name(AD,
     N : name
    ):->
	"Set the name" ::

	AD->>slot(name,N?makeGarp).
%%

%%
remarks(AD,
	Remarks : remarks = string
       ):->
	"Set a copy of the given string as remarks" ::

	AD->>slot(remarks,?(Remarks,strip,both)).
%%

%%
remarks(AD,
	Remarks : string
       ):<-
	"Return a copy of the remarks" ::

	RealRemarks = AD<<-slot(remarks),
	Remarks = RealRemarks<<-copy.
%%

%%
values(AD,
	Values : chain
	):->
	"Set the list of values as a copy of the given values" ::

	NewValues = Values<<-map(@arg1?copy), %Maar weer een kopie
	AD->>slot(values,NewValues).
%%

%%
values(AD,
	Values : chain):<-
	"Return a new list containing copies of the values (with same ID)" ::

	RV = AD<<-slot(values),
	Values = RV<<-map(@arg1?copy).
%%

%%
attributes(AD,
			A: chain
			):<-
	"Return a new chain with all attributes based on this definition" ::
	A = AD<<-all_named_hypered(garpAttribute).
%%

%%%%%%%%%%%%%CHANGES%%%%%%%%%%%%%%
%%
checkChange_addAttributeDef(AD,
	CR:changeRequestor):->
	%checken op naamconflict

	NewName = CR<<-argument(1),
	NewName->>equalExportName(AD?name),
	CR->>impossible('The given name is already used', AD).
%%

checkChange_changeAttributeDef(AD,
			    CR : changeRequestor
			   ):->
	%als we zelf het object van de change zijn checken we of
	%alle data correct is (via een norm methode bij het model)
	%als we niet zelf het object vd change zijn checken we op
	%naamconflict..

	%1: we zijn het object
	(   CR->>checkObject(AD) %we zijn dezelfde
	->  @model->>norm_attributeDef(CR,AD)
	;   %2: we zijn niet het object
	    NewName = CR<<-argument(1),
		NewName->>equalExportName(AD?name), %gelijk?
	    CR->>impossible('The given name is already used',AD)
	).
%
applyChange_changeAttributeDef(AD,
			      CR: changeRequestor
			     ):->
	%Deze definitie verandert dus
	
	AD->>name(?(CR,argument,1)),
	AD->>values(?(CR,argument,2)),
	AD->>remarks(?(CR,argument,3)).
%%

checkChange_addConfigurationDef(AD,
	CR:changeRequestor):->
	%checken op naamconflict: configuratie + attributen delen n namespace

	NewName = CR<<-argument(1),
	NewName->>equalExportName(AD?name),
	CR->>impossible('The given name is already used by an attribute', AD).
%%

%%
checkChange_changeConfigurationDef(AD,
			    CR : changeRequestor
			   ):->
	%checken op naamconflict bij gewijzigde configuratie
	
	NewName = CR<<-argument(1),
	NewName->>equalExportName(AD?name),
	CR->>impossible('The given name is already used by an attribute',AD).

:-pce_end_class.
		  
