:-
    use_module(owl).
:- use_module(library('semweb/rdf_db')).
    %use_module(library(semweb(rdf_db))),
    %use_module(library(semweb(rdfs))).
    /*
    rdf_reset_db,
    rdf_register_ns(qrm, 'http://phyro.mine.nu/model.owl'),
    rdf_register_ns(qr, 'http://phyro.mine.nu/qrontology.owl').
    */

outputfile('model.txt').

/*
go :-
    create_ontology('&qr;', 'http://phyro.mine.nu/qrontology.owl#'),
    %rdf_global_id(qr:'Aap', X),
    %print(X), nl,
    %rdf_assert(X, rdf:'type', owl:'Class'),
    %rdf_split_url(Base, Local, X),
    %rdf_assert(X, rdf:'label', literal(Local)),
    %create_class(qr:'#Aap', 'Monkey', []),
    %load_entities,
    owl_create_set('#GenderValue', ['#Male', '#Female', '#Nogwat']),
    outputfile(OutFile),
    rdf_save(OutFile).
*/


% Create a blank node
owl_create_node(Node) :-
    rdf_bnode(Node).


% Assert an objectproperty to the rdf database
create_objectproperty(Range, Property, Domain) :-
    rdf_assert(Property, rdf:type, owl:'ObjectProperty'),
    rdf_assert(Property, rdfs:range, Range),
    rdf_assert(Property, rdfs:domain, Domain),
    rdf_assert(Property, owl:inverseOf, wordtGegeten).


% Create a class 
% owl_create_class(+Class, -Node)
owl_create_class(Class, Label) :-
    %format('rdf_assert(~w, rdf:\'type\', owl:\'Class\')\n', [Class]),
    %format('rdf_assert(~w, rdfs:\'label\', literal(~w))\n', [Class, Label]),
    %format('owl_create_class(~w, ~w)\n', [Class, Label]),
    % Hack, as somehow Label is not a string or something
    %format('Het label is ~w\n', [Label]),
    term_to_atom(Label, Label2),
    atom_length(Label2, Length),
    End is Length - 2,
    sub_atom(Label2, 1, End, _Foo, Label3),
    %format('Het label is ~w\n', [Label3]),
    rdf_assert(Class, rdf:'type', owl:'Class'),
    rdf_assert(Class, rdfs:'label', literal(Label3)).    

owl_create_subclass(Node, Subclass) :-
    %rdf_global_id(Subclass, SubclassExpanded),
    rdf_assert(Node, rdfs:'subClassOf', Subclass).

% Add disjoint classes to a node
% owl_create_disjointclasses(+Node, +[DisjointClasses])
owl_create_disjointclasses(Node, DisjointClasses) :-
    forall( 
	member(DisjointClass, DisjointClasses),
	(
	    rdf_global_id(DisjointClass, DisjointClassExpanded),
	    rdf_assert(Node, owl:'disjointWith', DisjointClassExpanded)
	)
    ).

owl_create_comment(Node, Comment) :-
    rdf_assert(Node, rdfs:'comment', literal(Comment)).

owl_register_ns(NS, NSURL) :-
    rdf_register_ns(NS, NSURL).

owl_create_uri(NS, Label, URI) :-
    new(S, string('%s', Label)),
    send(S, translate, ' ', '_'),
    send(S, prepend, NS),
    get(S, value, URI),
    free(S).

% Assert a class to the rdf database
create_class(Class, Subclass, DisjointClasses) :-
    rdf_global_id(Class, ClassExpanded),
    rdf_assert(ClassExpanded, rdf:'type', owl:'Class'),
    rdf_assert(ClassExpanded, rdfs:'label', literal(Class)),
    rdf_assert(ClassExpanded, rdfs:'subClassOf', Subclass),
    forall( 
	member(DisjointClass, DisjointClasses),
	(
	rdf_global_id(DisjointClass, DisjointClassExpanded),
	rdf_assert(ClassExpanded, owl:'disjointWith', DisjointClassExpanded)
	)
	).

/*
rdf_db:rdf_assert('http://swi.psy.uva.nl/family#hanneke', 'http://www.w3.org/1999/02/22-rdf-syntax-ns#type', 'http://www.w3.org/2002/07/owl#Class', user)

rdf_edit:assert_action([26], assert(user), 'http://swi.psy.uva.nl/family#hanneke', 'http://www.w3.org/1999/02/22-rdf-syntax-ns#type', 'http://www.w3.org/2002/07/owl#Class')

rdf_edit:rdfe_assert('http://swi.psy.uva.nl/family#hanneke', 'http://www.w3.org/2000/01/rdf-schema#subClassOf', 'http://www.w3.org/2002/07/owl#Thing', user)


rdf_db:rdf_assert('http://swi.psy.uva.nl/family#hanneke', 'http://www.w3.org/1999/02/22-rdf-syntax-ns#type', 'http://www.w3.org/2002/07/owl#Class', user) ?

rdf_edit:rdfe_assert('http://swi.psy.uva.nl/family#hanneke', 'http://www.w3.org/2000/01/rdf-schema#subClassOf', 'http://swi.psy.uva.nl/family#person', user) 

rdf_edit:rdfe_assert('http://swi.psy.uva.nl/family#hanneke', 'http://www.w3.org/2000/01/rdf-schema#label', literal(hanneke), user) ?

*/

owl_type(Node, Type) :-
    rdf_assert(Node, rdf:'type', Type).

owl_property(Domain, Property, Range) :-
    rdf_assert(Domain, Property, Range).

owl_onProperty(Node, Property) :-
    rdf_assert(Node, owl:'onProperty', Property).

owl_create_restriction(Node, Property) :-
    rdf_bnode(Node),
    rdf_assert(Node, rdf:'type', owl:'Restriction'),
    owl_onProperty(Node, Property).

owl_allValuesFrom(Restriction, Class) :-
    rdf_assert(Restriction, owl:'allValuesFrom', Class).

owl_someValuesFrom(Restriction, Class) :-
    rdf_assert(Restriction, owl:'someValuesFrom', Class).

owl_hasValue(Restriction, Individual) :-
    rdf_assert(Restriction, owl:'hasValue', Individual).

owl_cardinality(Node, Integer) :-
    rdf_assert(Node, owl:'cardinality', literal(Integer)).

owl_minCardinality(Node, Integer) :-
    rdf_assert(Node, owl:'minCardinality', literal(Integer)).

owl_maxCardinality(Node, Integer) :-
    rdf_assert(Node, owl:'maxCardinality', literal(Integer)).

owl_oneOf(Node, ClassesList) :-
    rdf_bnode(NewNode),
    rdf_assert(Node, owl:'oneOf', NewNode),
    owl_create_list_thing(NewNode, ClassesList).

owl_intersectionOf(Node, ClassesList) :-
    rdf_bnode(NewNode),
    rdf_assert(Node, owl:'intersectionOf', NewNode),
    owl_create_list_class(NewNode, ClassesList).

owl_unionOf(Node, ClassesList) :-
    rdf_bnode(NewNode),
    rdf_assert(Node, owl:'unionOf', NewNode),
    owl_create_list_class(NewNode, ClassesList).

owl_distinctMembers(Node, IndividualsList) :-
    rdf_bnode(NewNode),
    rdf_assert(Node, owl:'distinctMembers', NewNode),
    owl_create_list_thing(NewNode, IndividualsList).

owl_create_individual(IndividualURI, Label, ClassURI) :-
    rdf_assert(IndividualURI, rdf:'type', ClassURI),
    %format('Individual: ~w en URI: ~w\n', [Label,IndividualURI]),
    rdf_assert(IndividualURI, rdfs:'label', literal(Label)).

owl_open_list(Node, First) :-
    rdf_bnode(Node),
    rdf_assert(Node, rdf:'type', rdf:'List'),
    rdf_assert(Node, rdf:'first', First).

owl_close_list(Node, Rest) :-
    rdf_assert(Node, rdf:'rest', Rest).
    
owl_create_list(Node, First, Rest) :-
    rdf_bnode(Node),
    rdf_assert(Node, rdf:'type', rdf:'List'),
    rdf_assert(Node, rdf:'first', First),
    rdf_assert(Node, rdf:'rest', Rest).

%owl_create_set(ClassName, [SetElement|SetElements]) :-
%    create_class(ClassName, '#Entity', []),
%    rdf_bnode(Set),
%    rdf_assert(Set, rdf:'type', rdf:'List'), 
%    rdf_assert(Set, rdf:'first', SetElement),
%    rdf_assert(Set, rdf:'rest', rdf:'nil'),  
%    rdf_assert(ClassName, owl:'unionOf', Set),
%    owl_create_list_items(Set, SetElements).

%owl_create_list(_, []).

owl_create_list_class(Node, [Element|RestList]) :-
    rdf_assert(Node, rdf:'type', rdf:'List'),
    %rdf_bnode(ListTarget),
    %rdf_assert(ListTarget, rdf:'about', literal(Element)),
    %rdf_assert(ListTarget, rdf:'type', owl:'Class'), 
    rdf_assert(Element, rdf:'type', owl:'Class'),
    rdf_assert(Node, rdf:'first', Element),
    rdf_assert(Node, rdf:'rest', rdf:'nil'),
    %rdf_assert(Node, rdf:'rest', rdf:'nil').
    (
    	RestList \== [], !, 
    	rdf_bnode(NewNode),
    	rdf_update(Node, rdf:'rest', rdf:'nil', object(NewNode)),
    	owl_create_list_class(NewNode, RestList)
    )
    ;
    (
	% End Statement
	true
    ).

owl_create_list_thing(Node, [Element|RestList]) :-
    rdf_assert(Node, rdf:'type', rdf:'List'),
    %rdf_node(ListTarget),
    %rdf_assert(listTarget, rdf:'about', literal(Element)),
    %rdf_assert(Element, rdf:'type', owl:'Thing'), 
    rdf_assert(Node, rdf:'first', Element),
    rdf_assert(Node, rdf:'rest', rdf:'nil'),
    %rdf_assert(Node, rdf:'rest', rdf:'nil').
    (
    	RestList \== [], !, 
    	rdf_bnode(NewNode),
    	rdf_update(Node, rdf:'rest', rdf:'nil', object(NewNode)),
    	owl_create_list_thing(NewNode, RestList)
    )
    ;
    (
	% End Statement
	true
    ).



%owl_create_list_items(_,[]).

%owl_create_list_items(Hook, [Element|Elements]) :-
%    rdf_bnode(NewHook),
%    rdf_assert(NewHook, rdf:'type', rdf:'List'),
%    rdf_assert(NewHook, rdf:'first', Element),
%    rdf_assert(NewHook, rdf:'rest', rdf:'nil'),  
%    rdf_update(Hook, rdf:'rest', rdf:'nil', object(NewHook)),
    %rdf_update(Hook, rdf:'type', rdf:'List', literal('owl:Class')),
    %    owl_create_list_items(NewHook, Elements). 

    
    /*
    rdf_bnode(Set),
    rdf_assert(Set, rdf:'type', rdf:'List'),
    rdf_assert(Set, rdf:'rest', rdf:'nil'),
    rdf_update(Set, rdf:'type', rdf:'List', object(owl:'Class')),
    % test
    %rdf_bnode(OwlClass),
    %rdf_assert(OwlClass, rdf:'type', owl:'Class'),
    %rdf_assert(OwlClass, rdf:'about', '#Male'),
    % end test
    rdf_assert(Set, rdf:'first', '#Gender'),
    rdf_assert('#Gender', owl:'unionOf', Set),
    rdf_bnode(SetElement2),
    rdf_update(Set, rdf:'rest', rdf:'nil', object(SetElement2)),
    rdf_assert(SetElement2, rdf:'type', rdf:'List'),
    rdf_assert(SetElement2, rdf:'rest', rdf:'nil'),
    rdf_assert(SetElement2, rdf:'first', '#Female').

    %rdf_assert(Id, rdf:'type', owl:'Restriction').
    */



    %create_individual :- true.
/*

Create Individual:
rdf_db:rdf_assert('http://swi.psy.uva.nl/family#hanneke', 'http://www.w3.org/1999/02/22-rdf-syntax-ns#type', 'http://swi.psy.uva.nl/family#person', user)
*/

create_ontology(_ImportShorthand, ImportURL) :-
    % rdf_register_ns(ImportShorthand, ImportURL),
    rdf_assert('', rdf:'type', owl:'Ontology'),
    rdf_assert('', owl:'imports', ImportURL).

/*
    <owl:Ontology rdf:about="">
        <rdfs:comment>A Qualitative Model of a U-Tube System</rdfs:comment>
        <owl:versionInfo>Version 1</owl:versionInfo>
        <rdfs:label xml:lang="en">Qualitative Model of a U-Tube System</rdfs:label>
        <rdfs:label xml:lang="nl">Qualitatief Model van een Communicerende Vaten Systeem</rdfs:label>
        <owl:imports rdf:resource="http://phyro.mine.nu/~phyro/qrontology.owl"/>
    </owl:Ontology>

owl_assert(A, B:C, D:E) :-
	rdf_assert(A, B:C, D:E).
*/

